package com.zcxk.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zcxk.dto.RoleDto;
import com.zcxk.dto.RoleRequestDto;
import com.zcxk.entity.Role;
import com.zcxk.entity.RoleOrg;
import com.zcxk.entity.UserEntity;

import java.util.List;

/**
 * 角色(Role)表服务接口
 *
 * @author makejava
 * @since 2020-10-27 09:13:27
 */
public interface RoleService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Role selectById(Integer id);


    /**
     * 查询全部
     *
     * @return 对象列表
     */
    List<Role> selectAll();

    /**
     * 通过实体作为筛选条件查询
     *
     * @param role 实例对象
     * @return 对象列表
     */
    List<Role> selectList(Role role);

    /**
     * 新增数据
     *
     * @param role 实例对象
     * @return 影响行数
     */
    int insert(RoleRequestDto role);

    /**
     * 批量新增
     *
     * @param roles 实例对象的集合
     * @return 影响行数
     */
    int batchInsert(List<Role> roles);

    /**
     * 修改数据
     *
     * @param role 实例对象
     * @return 修改
     */
    int update(RoleRequestDto role);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<String> deleteAll(List<Integer> ids);

    /**
     * 查询总数据数
     *
     * @return 数据总数
     */
    int count();

    IPage<RoleDto> selectPage(Role role, IPage<RoleDto> page);

    IPage<UserEntity> findUsersByRole(Role role, IPage<UserEntity> iPage);

    int updateRoleMenuRelations(RoleRequestDto dto);

    List<RoleOrg> getRoleOrgs(RoleOrg roleOrg);

    Role getRoleMenuByRoleId(Integer id);
}